"""Fix unique contraints on user table

Revision ID: 35a9589296f9
Revises: 3e74212e37b4
Create Date: 2021-06-21 13:49:59.150749

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '35a9589296f9'
down_revision = '3e74212e37b4'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    # Because the unique contraint on user.name is not NAMED, we need to apply a work-around to remove it.
    # First define a naming convention for unique contraints:
    naming_convention = {
        "uq": "%(column_0_name)s",
    }

    # With the batch_alter_table method a naming_convention can be given, this magically also makes an
    # unnamed constrained adhere to the naming convention, so we are able to to drop it (JEEJ).
    with op.batch_alter_table("user", naming_convention=naming_convention) as batch_op:
        batch_op.drop_constraint("name", type_="unique")

    op.create_unique_constraint('uq_user_email', 'user', ['email'])
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint('uq_user_email', 'user', type_='unique')
    op.create_unique_constraint('name', 'user', ['name'])
    # ### end Alembic commands ###
